from __future__ import print_function, division


EVENTS = []
LAST_TICKET = 0
SCHEDULED = []


def push(event):
    EVENTS.append(event)

def clear():
    global EVENTS
    EVENTS = []

def get():
    for event in EVENTS:
        yield event

def schedule(event, func, repeat=False):
    SCHEDULED.append((event, func, repeat))

def check_schedule():
    for event in get():
        for item in SCHEDULED:
            trigger, func, repeat = item
            if event == trigger:
                func()
                if not repeat:
                    SCHEDULED.remove(item)

def ticket():
    global LAST_TICKET
    LAST_TICKET += 1
    return LAST_TICKET


class Event(object):
    def __init__(self, kind, value):
        self.kind = kind
        self.value = value

    def __eq__(self, other):
        return (self.kind == other.kind and self.value == other.value)
